use strict;
#------------------------------------------------------------------------------
# gzip圧縮／伸長モジュール
#						(C)2006-05 nabe / nabe@abk.nu
#------------------------------------------------------------------------------
package Satsuki::Base::Gzip;
our $VERSION = '1.00';
#------------------------------------------------------------------------------
my $gzip_cmd = 'gzip -1 -c';
my $zcat_cmd = 'gzip -d -c';
###############################################################################
# ■基本処理
###############################################################################
#------------------------------------------------------------------------------
# ●【コンストラクタ】
#------------------------------------------------------------------------------
sub new {
	my $self = bless({}, shift);
	$self->{ROBJ} = shift;

	return $self;
}

###############################################################################
# ■メインルーチン
###############################################################################
#------------------------------------------------------------------------------
# ●gzip でファイルを圧縮
#------------------------------------------------------------------------------
sub compress {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($file) = @_;

	$file =~ s/[^\w\-\.\/ ]//g;
	$file = $ROBJ->get_filepath( $file );
	return system("$gzip_cmd \"$file\" >$file.gz");
}

#------------------------------------------------------------------------------
# ●gzip ファイルを読み込み
#------------------------------------------------------------------------------
sub zcat {
	my $self = shift;
	my $ROBJ = $self->{ROBJ};
	my ($file, $data_ref, $max_size) = @_;
	if (ref($data_ref) ne 'SCALAR') { return 0; }

	$file  =~ s/[^\w\-\.\/ ]//g;
	$file  = $ROBJ->get_filepath( $file );
	my $fh;
	open($fh, "$zcat_cmd \"$file\" |");
	my $readsize = read($fh, $$data_ref, $max_size);
	close($fh);
	return $readsize;
}

1;
